/**
 * ===========================================
 * LibLayout : a free Java layouting library
 * ===========================================
 *
 * Project Info:  http://reporting.pentaho.org/liblayout/
 *
 * (C) Copyright 2006-2007, by Pentaho Corporation and Contributors.
 *
 * This library is free software; you can redistribute it and/or modify it under the terms
 * of the GNU Lesser General Public License as published by the Free Software Foundation;
 * either version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
 * without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License along with this
 * library; if not, write to the Free Software Foundation, Inc., 59 Temple Place, Suite 330,
 * Boston, MA 02111-1307, USA.
 *
 * [Java is a trademark or registered trademark of Sun Microsystems, Inc.
 * in the United States and other countries.]
 *
 * ------------
 * $Id: ListStyleTypeNumeric.java 6653 2008-12-02 14:53:40Z tmorgner $
 * ------------
 * (C) Copyright 2006-2007, by Pentaho Corporation.
 */
package org.jfree.layouting.input.style.keys.list;

import org.jfree.layouting.input.style.values.CSSConstant;

/**
 * Creation-Date: 01.12.2005, 18:53:03
 *
 * @author Thomas Morgner
 */
public class ListStyleTypeNumeric
{
  public static final CSSConstant ARABIC_INDIC =
          new CSSConstant("arabic-indic");
  public static final CSSConstant BINARY =
          new CSSConstant("binary");
  public static final CSSConstant BENGALI =
          new CSSConstant("bengali");
  public static final CSSConstant CAMBODIAN =
          new CSSConstant("cambodian");
  public static final CSSConstant DECIMAL =
          new CSSConstant("decimal");
  public static final CSSConstant DECIMAL_LEADING_ZERO =
          new CSSConstant("decimal-leading-zero");
  public static final CSSConstant DEVANAGARI =
          new CSSConstant("devanagari");
  public static final CSSConstant GUJARATI =
          new CSSConstant("gujarati");
  public static final CSSConstant GURMUKHI =
          new CSSConstant("gurmukhi");
  public static final CSSConstant KANNADA =
          new CSSConstant("kannada");
  public static final CSSConstant KHMER =
          new CSSConstant("khmer");
  public static final CSSConstant LAO =
          new CSSConstant("lao");
  public static final CSSConstant LOWER_HEXADECIMAL =
          new CSSConstant("lower-hexadecimal");
  public static final CSSConstant MALAYALAM =
          new CSSConstant("malayalam");
  public static final CSSConstant MONGOLIAN =
          new CSSConstant("mongolian");
  public static final CSSConstant MYANMAR =
          new CSSConstant("myanmar");
  public static final CSSConstant OCTAL =
          new CSSConstant("octal");
  public static final CSSConstant ORIYA =
          new CSSConstant("oriya");
  public static final CSSConstant PERSIAN =
          new CSSConstant("persian");
  public static final CSSConstant TELUGU =
          new CSSConstant("telugu");
  public static final CSSConstant TIBETIAN =
          new CSSConstant("tibetian");
  public static final CSSConstant THAI =
          new CSSConstant("thai");
  public static final CSSConstant UPPER_HEXADECIMAL =
          new CSSConstant("upper-hexadecimal");
  public static final CSSConstant URDU =
          new CSSConstant("urdu");

  private ListStyleTypeNumeric()
  {
  }
}
